/*{{TIDC_Wizard Auto Code Start                                 */
/****************************************************************/
/* don't change anything here until you know what you are doing!*/
/* the plug-in will change all text between the code marks      */
/* without user interaction!                                    */
/*                                                              */
/****************************************************************/

/****************************************************************/
/* software generated by Data Converter Plug-in (DCP)           */
/* based on <C:\CCSTUD~1.1\PLUGINS\AAP_DEV\c6000\d8401_62.c> */
/****************************************************************/
/****************************************************************/
/* ADS8412 interface software version 2.0 for the TMS320C67xx   */
/* Copyright (C) 2004 - 2006 Texas Instruments Incorporated     */
/* All Rights Reserved                                          */
/*--------------------------------------------------------------*/
/** \file
 *  This interface software needs one interrupt to be mapped in
 *  either the DSP/BIOS configuration file or the interrupt
 *  vector table:
 *      EDMA controller interrupt: DCPDISP_dispatchEdmaIsr()
 *
 * This interface software uses two peripherals:
 *   - One EDMA channel (for data transfer)
 *   - One Timer (for the CONVST\)
 *
 * <b>Restrictions:
 *    - This interface software does not support the byte wide
 *      transfers of the ADS8412, as all of the DSPs feature a
 *      16 bit bus
 *    - It is only possible to submit two buffers at a time. If a
 *      third buffer needs to be submitted, the application has
 *      to wait until the xferInProgress member of the data
 *      converter structure is less than two.
 *    - This version 2.0 is not binary compatible with previous
 *      versions of this software.
 *    - The timings of the external memory interface are
 *      optimized for the TMS320C6713 DSK running at the EMIF
 *      at 100 MHz.If a different H/W platform or a different
 *      EMIF speed is used, the values in the ADS8412_RD_SETUP,
 *      ADS8412_RD_STROBE and ADS8412_RD_HOLD makros below have to
 *      be changed to match the H/W.
 *    - This software requiresthe buffer to be of type short or
 *      unsigned short, depending on the used device.</b>
 */
/*--------------------------------------------------------------*/
/* $Revision: 8 $                         $JustDate:  6/02/06 $ */
/* $Author: A0746714 $                                          */
/****************************************************************/
#undef _INLINE


/* Include the interface files for the driver                   */
#include "dc_conf.h"
#include "t8412_fn.h"


/* Include the interface files for the chip support library     */
#include <csl.h>
#include <csl_cache.h>
#include <csl_emif.h>
#include <csl_irq.h>


/* The following settings for the EMIF are optimized for the    */
/* C6713 DSK. If you are using a different H/W, you might want  */
/* change these settings to match your hardware                 */
#define ADS8412_CECTRL_MASK    (0xFFF0C008)
#define CECTRL0                (0x01800008)
#define CECTRL1                (0x01800004)
#define CECTRL2                (0x01800010)
#define CECTRL3                (0x01800014)
#define ADS8412_MTYPE          (2)
#define ADS8412_RD_SETUP       (1)
#define ADS8412_RD_STROBE      (3)
#define ADS8412_RD_HOLD        (1)


/* some other usefull defines                                   */
#define ADS8412_TIMER_NOTUSED  (-1)
#define ADS8412_EMIF_SETUP_YES (1)
#define ADS8412_MAX_BLOCKS     (2)
#define ADS8412_MAX_BLOCKSIZE  (0x0000FFFFul)
#define ADS8412_MIN_BLOCKSIZE  (0x00000002ul)


/* This driver does not support the older devices, as they have */
/* a different DMA controller                                   */
#if CHIP6701 | CHIP6201 | CHIP6202 | CHIP6203 | CHIP6204 | CHIP6205
#error Selected DSP is not supported by that software
#endif




/****************************************************************/
/* define and initialize data converter objects                 */
/****************************************************************/
TADS8412 Ads8412_1 = {
    &ADS8412_configure,
    &ADS8412_control,
    &ADS8412_readsample,
    &ADS8412_writesample,
    &ADS8412_readblock,
    &ADS8412_writeblock,
    &ADS8412_close,
    0, 0, 3,            /* reserved                         */
    0, 0, 0, 0,         /* buffer object 0                  */
    0, 0, 0, 0,         /* buffer object 1                  */
    0,                  /* timer handle                     */
    0,                  /* (E)DMA handle                    */
    0,                  /* link table pointer               */
    0,                  /* stop table pointer               */
    (volatile unsigned short*)ADC1_RD_ADDR, /* ADC read addr */
    ADC1_INTPOL,        /* IRQ polarity of BUSY\            */
    ADC1_CONVST_PERIOD, /* sampling period                  */
    0,                  /* LRU buffer object ptr            */
    ADC1_INTNUM,        /* IRQ number of BUSY\              */
    ADC1_EMIF_CONFIGURE,/* EMIF setup to do?                */
    ADC1_TIMER,         /* used timer, if any               */
    0                   /* xfer on progress flag            */
};



/****************************************************************/
/* local DSP function prototypes                                */
/****************************************************************/
static TTIDCSTATUS ConfigIntPolarity(unsigned int uiBusyIntPol,
                       unsigned int uiBusyIntNum);
static TTIDCSTATUS InitConvstTimer(TIMER_Handle *hTimer,
                       unsigned int uiPeriod,
                       int iTimerNumber);
static TTIDCSTATUS InitEdma(unsigned int *hEdma,
                       unsigned int *hLink,
                       unsigned int *hStop,
                       unsigned int uiIntNumber);
static TTIDCSTATUS InitEmif(volatile unsigned short *pAddress);
static TTIDCSTATUS SubmitBlock(EDMA_Handle hSubmit,
                       unsigned int uiAdsAddress,
                       unsigned int uiBufAddress,
                       unsigned int uiCount,
                       unsigned int uiIntNumber,
                       EDMA_Handle hPrevious,
                       EDMA_Handle hStop);


/****************************************************************/
/* ADS8412_configure()                                          */
/**
 * Operation:     The following operations are performed:
 *     - Opens and configures the timer needed for the correct
 *       sampling frequency, if the use of a timer was selected
 *       in the graphical user interface. Returns on error.
 *     - Configures the EMIF to the correct timings, if this was
 *       requested by the user during configuration.
 *     - Configures the external interrupt polarity register to
 *       match the polarity of the BUSY\ signal.
 *     - Opens the EDMA channel needed for the transfer.
 *       Returns on error.
 *     - Acquires the handles for the EDMA link and stop transfer
 *       tables. Returns on error.
 *     - Registers the EDMA transfer complete code with the EDMA
 *       interrupt dispatcher.
 *
 * Parameters:
 *     - void* pDC: Data converter object
 *
 * Return values: Status code of type TTIDCSTATUS
 *     - TIDC_NO_ERR: Call was successful
 *     - TIDC_ERR_NODEVICE: No object was passed to the function
 *     - TIDC_ERR_TIMER: The timer could not be opened
 *     - TIDC_ERR_EDMA: The EDMA channel could not be opened or
 *       one of the link tables could not be allocated.
 *     - TIDC_ERR_XFERPROG: dc_configure was called during an
 *       ongoing transfer
 *     - TIDC_ERR_BADARGS: An invalid argument was passed to the
 *       function
 *
 * Globals modified: In the data converter object:
 *     - hConvstTimer
 *     - hEdmaRead
 *     - hEdmaLinkRead
 *     - hEdmaStop
 *
 * Resources used:
 *     - One Timer
 *     - One EDMA channel
 *     - Two EDMA link tables
*/
/****************************************************************/
TTIDCSTATUS ADS8412_configure(void *pDC)
{
    TADS8412 *pADS = pDC;
    TTIDCSTATUS iStatus;
    unsigned int uiIntNumber;


    /* return, if no device object available                    */
    if (pADS == 0)
        return TIDC_ERR_NODEVICE;


    /* be sure no block transfer is in progress                 */
    if (pADS->xferInProgress !=0)
        return TIDC_ERR_XFERPROG;


    uiIntNumber = pADS->busyIntNum;


    /* open and configure the timer for the CONVST\ signal      */
    /* this call will initialize the hConvstTimer field of the  */
    /* data converter object; return on error                   */
    if (pADS->iTimerNumber != ADS8412_TIMER_NOTUSED)
    {
        iStatus = InitConvstTimer(&pADS->hConvstTimer,
                                  pADS->convstTimerPeriod,
                                  pADS->iTimerNumber);
        if (iStatus != TIDC_NO_ERR)
            return iStatus;


        uiIntNumber = TIMER_getEventId(pADS->hConvstTimer);
    }


    /* configure the EMIF if selected by the customer           */
    if (pADS->emifSetup == ADS8412_EMIF_SETUP_YES)
        (void)InitEmif(pADS->adcReadAdr);


    /* configure the polarity used for the BUSY\ signal. This   */
    /* is needed for the ADS8412_readsample() function          */
    iStatus = ConfigIntPolarity(pADS->busyIntPol,pADS->busyIntNum);
    if (iStatus != TIDC_NO_ERR)
    {
        (void)ADS8412_close(pADS);
        return iStatus;
    }


    /* open the EDMA channel for the data transfer              */
    iStatus = InitEdma(&pADS->hEdmaRead,
                       &pADS->hEdmaLinkRead,
                       &pADS->hEdmaStop,
                       uiIntNumber);
    if (iStatus != TIDC_NO_ERR)
    {
        (void)ADS8412_close(pADS);
        return iStatus;
    }


    /* register the EDMA transfer complete code with the EDMA   */
    /* interrupt dispatcher                                     */
    iStatus = DCPDISP_registerIsr((void*)pADS,
                                 ADS8412_rblock_finished,
                                 uiIntNumber);
    if (iStatus != TIDC_NO_ERR)
    {
        (void)ADS8412_close(pADS);
        return iStatus;
    }


    /* now everything is setup, so start the conversions        */
    TIMER_start(pADS->hConvstTimer);


    return TIDC_NO_ERR;
}




/****************************************************************/
/* ADS8412_control()                                            */
/** Operation:
 *     - None, as this device supports no S/W or H/W control
 *
 * Parameters:
 *     - void* pDC: Data converter object
 *     - int iCmd:  Action to be performed.
 *     - void *pValue: Additional parameters for the command.
 *
 * Return value:
 *     - TIDC_ERR_FXNNULL, signalling that this function is not
 *       performing any action
 *
 * Globals modified:None
 *
 * Resources used:  None
 */
/****************************************************************/
TTIDCSTATUS ADS8412_control(void *pDC, int iCmd, void *pValue)
{
    return TIDC_ERR_FXNNULL;
}




/****************************************************************/
/* ADS8412_readsample()                                         */
/**Operation:
 *     - Reads a single 16 bit word from the ADS8412
 *     - If the internal timer is used for the generation of the
 *       CONVST\ signal, it waits for the next timer interrupt.
 *       If the timer is not used, it waits for the next falling
 *       edge of the BUSY\ signal.
 *     - Reads the data word from the converter.
 *     - This routine is not interrupt driven, but uses the
 *       polling method instead
 *
 * Parameters:
 *     - void *pDC: Data converter object
 *     - long *lData: Memory location used to return the
 *       conversion result (out-parameter).
 *
 * Return value:  Status code of type TTIDCSTATUS
 *     - TIDC_NO_ERR: Call was successfull.
 *     - TIDC_ERR_NODEVICE: No object was passed to the function.
 *     - TIDC_ERR_XFERPROG: A block transfer is in progress, so
 *       this function cannot be executed.
 *
 * Globals modified:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
TTIDCSTATUS ADS8412_readsample(void *pDC, long * lData)
{
    TADS8412 *pADS = pDC;
    unsigned int uiIntNumber;


    /* return, if no device object available                    */
    if (pADS == 0)
        return TIDC_ERR_NODEVICE;


    /* return, if a block transfer is ongoing                   */
    if (pADS->xferInProgress !=0)
        return TIDC_ERR_XFERPROG;


    if (pADS->iTimerNumber != ADS8412_TIMER_NOTUSED)
        uiIntNumber = TIMER_getEventId(pADS->hConvstTimer);
    else uiIntNumber = pADS->busyIntNum;


    IRQ_clear(uiIntNumber);      /* clear any old interrupt     */


    /* wait for the next interrupt; this is a blocking statement*/
    while((IRQ_test(uiIntNumber)) == 0);


    *lData = (long)(*(pADS->adcReadAdr));


    return TIDC_NO_ERR;
}




/****************************************************************/
/* ADS8412_readblock()                                          */
/**Operation:
 *     - Initializes the transfer of a block of data from the
 *       ADS8412. Once the transfer is started, the function
 *       returns to the application level.
 *     - It uses one EDMA channel for the data transfer.
 *     - The EDMA channel for the collection of the data samples
 *       is synchronized to the BUSY signal, if no DSP timer is
 *       used for the creation of the CONVST\ signal. If a DSP
 *       timer is used, the timer interrupt will be used instead.
 *     - Once the transfer is complete, the ADS8412_rblock_finished
 *       routine will be called, which then signals the end of the
 *       transfer to the application level by the means of a
 *       callback function.
 *
 * Parameters:
 *     - void *pD:CData converter object
 *     - void *pData: Pointer to the data block
 *     - unsigned long ulCount: Number of words to be read
 *     - void *readCallback: Pointer to callback function
 *
 * Return value:
 *     - None
 *
 * Globals modified:
 *     - Inside the data converter object:
 *         - iObjectIndex
 *         - xferInProgress
 *     - Inside the xferBuffer object:
 *         - usbufPtr
 *         - uibufSize
 *         - uiStatus
 *         - ptrCallback
 *
 * Resources used:
 *     - One EDMA channel (opened by ADS8412_configure())
 *
 * Remarks:
 *     - Only one buffer can be active at one time while a
 *       second buffer can be submitted.
 *     - No single word transfer is allowed. The ADS8412_readsample()
 *       routine should be used instead.
 *     - The number of samples to be transfered cannot exceed
 *       0xffff.
 */
/****************************************************************/
TTIDCSTATUS ADS8412_readblock(void *pDC,
                              void *pData,
                              unsigned long ulCount,
                              void (*readCallback) (void *))
{
    TADS8412 *pADS = pDC;
    unsigned int uiIntNumber;


    /* no single word transfer is allowed.Also return if the    */
    /* maximum number of transfers was already submitted        */
    if(pADS == 0)
        return TIDC_ERR_NODEVICE;
    if ((ulCount > ADS8412_MAX_BLOCKSIZE)
        || (ulCount < ADS8412_MIN_BLOCKSIZE))
        return TIDC_ERR_BADARGS;


    if (pADS->xferInProgress == ADS8412_MAX_BLOCKS)
        return TIDC_ERR_XFERPROG;
    else
        pADS->xferInProgress += 1;


    /* select the next free buffer object                       */
    if (pADS->xferBuffer[0].uiStatus == ADS8412_BUFOBJECT_FREE)
        pADS->iObjectIndex = 0; /* object 0 is free             */
    else
        pADS->iObjectIndex = 1; /* object 1 is free             */


    pADS->xferBuffer[pADS->iObjectIndex].ptrCallBack = readCallback;
    pADS->xferBuffer[pADS->iObjectIndex].usBufPtr = (unsigned short *)pData;
    pADS->xferBuffer[pADS->iObjectIndex].uiBufSize = (unsigned int)ulCount;
    pADS->xferBuffer[pADS->iObjectIndex].uiStatus = ADS8412_BUFOBJECT_INUSE;


    /* make sure the cache is coherent                          */
    CACHE_wbInvL1d((void *)pData,
                   2 * (unsigned int)ulCount,
                   CACHE_WAIT);


    if (pADS->iTimerNumber != ADS8412_TIMER_NOTUSED)
        uiIntNumber = TIMER_getEventId(pADS->hConvstTimer);
    else
        uiIntNumber = pADS->busyIntNum;


    /* there is no transfer running and no transfer pending     */
    if (pADS->xferInProgress == 1)
    {
        /* submit the block for the data transfer               */
        (void)SubmitBlock(pADS->hEdmaRead,
               (unsigned int)pADS->adcReadAdr,
               (unsigned int)pADS->xferBuffer[pADS->iObjectIndex].usBufPtr,
               pADS->xferBuffer[pADS->iObjectIndex].uiBufSize,
               uiIntNumber,
               (EDMA_Handle)0,
               pADS->hEdmaStop);


        /* start the EDMA channel                               */
        EDMA_clearChannel(pADS->hEdmaRead);
        EDMA_intClear(uiIntNumber);
        EDMA_intEnable(uiIntNumber);
        EDMA_enableChannel(pADS->hEdmaRead);


        IRQ_enable(IRQ_EVT_EDMAINT);    /* enable the EDMA interrupt*/
    }


    if (pADS->xferInProgress == 2)
        /* queue the block for the data transfer                */
        (void)SubmitBlock(pADS->hEdmaLinkRead,
               (unsigned int)pADS->adcReadAdr,
               (unsigned int)pADS->xferBuffer[pADS->iObjectIndex].usBufPtr,
               pADS->xferBuffer[pADS->iObjectIndex].uiBufSize,
               uiIntNumber,
               pADS->hEdmaRead,
               pADS->hEdmaStop);


    /* return to the calling routine                            */
    return TIDC_NO_ERR;
}


/****************************************************************/
/* ADS8412_writesample()                                        */
/**Operation:
 *     Not implemented. This function just returns.
 *
 * Parameters:
 *     - void* pDC: Data converter object
 *     - long lData: Data to be written to the converter
 *
 * Return value:  Status code of type TTIDCSTATUS
 *     - TIDC_ERR_FXNNULL: This function is not implemented
 *
 * Globals modified:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
TTIDCSTATUS ADS8412_writesample(void *pDC, long lData)
{
    return TIDC_ERR_FXNNULL;
}




/****************************************************************/
/* ADS8412_writeblock()                                         */
/**Operation:
 *     - Not implemented. This function just returns.
 *
 * Parameters:
 *     - void* pDC: Data converter object
 *     - void* lData: Pointer to the block of data to be written
 *     - unsigned long ulCount: Number of words
 *     - void (*callback): Pointer to the callback function
 *
 * Return value:  Status code of type TTIDCSTATUS
 *     - TIDC_ERR_FXNNULL: This function is not implemented
 *
 * Globals modified:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
TTIDCSTATUS ADS8412_writeblock(void *pDC, void *pData,
                               unsigned long ulCount,
                               void (*callback) (void *))
{
    return TIDC_ERR_FXNNULL;
}




/****************************************************************/
/* ADS8412_close()                                              */
/**Operation:
 *     - Closes all the resources used on the DSP.
 *     - Unregisters the interrupt service routine with the EDMA
 *       interrupt dispatcher
 *
 * Parameters:
 *     - void* pDC: Data converter object
 *
 * Return value:  Status code of type TTIDCSTATUS
 *     - TIDC_NO_ERR: No problem occurred
 *
 * Globals modified: The following items are modified inside
 *     data converter object:
 *     - hConvstTimer
 *     - hEdmaRead
 *     - hEdmaLinkRead
 *     - hEdmaStop
 *     - xferInProgress
 *     - iObjectIndex
 *
 * Resources used:
 *     - One EDMA channel (closed)
 *     - Two EDMA link tables (freed)
 *     - One timer (closed)
 */
/****************************************************************/
TTIDCSTATUS ADS8412_close(void *pDC)
{
    TADS8412 *pADS = pDC;
    unsigned int uiIntNumber;


    /* return, if no device object available                    */
    if (pADS == 0)
        return TIDC_ERR_NODEVICE;


    /* was BUSY\ or the timer used for synchrtonization?        */
    if  (pADS->iTimerNumber != ADS8412_TIMER_NOTUSED)
        uiIntNumber = TIMER_getEventId(pADS->hConvstTimer);
    else
        uiIntNumber = pADS->busyIntNum;


    /* close the EDMA channel, if they have been opened         */
    if ((pADS->hEdmaRead != 0) && (pADS->hEdmaRead != EDMA_HINV))
    {
        EDMA_intDisable(uiIntNumber);
        EDMA_disableChannel(pADS->hEdmaRead);
        EDMA_close(pADS->hEdmaRead);
        pADS->hEdmaRead = 0;
    }


    /* free the tables associated with the transfer             */
    if ((pADS->hEdmaLinkRead != 0)
        && (pADS->hEdmaLinkRead != EDMA_HINV))
    {
        EDMA_freeTable(pADS->hEdmaLinkRead);
        pADS->hEdmaLinkRead = 0;
    }
    if ((pADS->hEdmaStop != 0) && (pADS->hEdmaStop != EDMA_HINV))
    {
        EDMA_freeTable(pADS->hEdmaStop);
        pADS->hEdmaStop = 0;
    }


    /* close the timer, if it was open                          */
    if ((pADS->hConvstTimer != 0) && (pADS->hConvstTimer != INV))
    {
        TIMER_close(pADS->hConvstTimer);
        pADS->hConvstTimer = 0;
    }


    /* unregister the EDMA transfer complete code with the      */
    /* EDMA interrupt dispatcher                                */
    (void)DCPDISP_unregisterIsr(uiIntNumber);


    /* reset the transfer in progress semaphore                 */
    pADS->xferInProgress = 0;
    pADS->iObjectIndex = 0;
    pADS->xferBuffer[0].uiStatus = ADS8412_BUFOBJECT_FREE;
    pADS->xferBuffer[1].uiStatus = ADS8412_BUFOBJECT_FREE;


    return TIDC_NO_ERR;
}


/****************************************************************/
/* ADS8412_rblock finished()                                    */
/**Operation:
 *     - This function was registered with the DCP EDMA interrupt
 *       dispatcher by the ADS8412_configure() function.
 *     - It masks and adjusts the data read by the EDMA from the
 *       data converter.
 *     - Cleans up the cache.
 *     - If requested, a user-defined callback function will be
 *       called at the end..
 *
 * Parameters:
 *    - void *pDC: Data converter object. Will be provided by
 *      the DCP EDMA interrupt dispatcher
 *
 * Return value (of type TTIDCSTATUS):
 *     - TIDC_ERR_NODEVICE: The passed data converter object is
 *       not valid
 *     - TIDC_NO_ERR: Everything is fine
 *
 * Globals modified: In the data converter object:
 *     - xferInPorgress
 *     - uiStatus inside the transfer buffer object
 *
 * Resources used:  None
 */
/****************************************************************/
TTIDCSTATUS ADS8412_rblock_finished(void *pDC)
{
    TADS8412 *pADS = pDC;
    int iIndex;




    if (pADS == 0)
        return TIDC_ERR_NODEVICE;


    if (pADS->xferInProgress == 2)
        iIndex = (pADS->iObjectIndex + 1) & 0x0001;
    else
    {
        iIndex = pADS->iObjectIndex;
        EDMA_disableChannel(pADS->hEdmaRead);
    }


    if (pADS->xferBuffer[iIndex].ptrCallBack)
    {
        pADS->xferBuffer[iIndex].uiStatus = ADS8412_BUFOBJECT_COMPLETE;
        pADS->xferBuffer[iIndex].ptrCallBack(pADS);
    }
    pADS->xferBuffer[iIndex].uiStatus = ADS8412_BUFOBJECT_FREE;


   /* signal that the transfer was successful                   */
   pADS->xferInProgress -= 1;         /* clear flag             */


   return TIDC_NO_ERR;
}




/****************************************************************/
/* ConfigIntPolarity():                                         */
/**Operation:
 *    - Configures the external interrupt polarity register to
 *      match the polarity of the BUSY\ signal.
 *
 * Parameters:
 *     - unsigned int uiBusyIntPol: BUSY\ interrupt polarity as
 *       selected in  the graphical user interface
 *     - unsigned int uiBusyIntNum: The number of the external
 *       interrupt the BUSY\ signal is connected to.
 *
 * Return values: Of type TTIDCSTATUS:
 *     - TIDC_NO_ERR: No error occurred
 *     - TIDC_ERR_BADARGS: The interrupt passed is not an
 *       external interrupt
 *
 * Globals modified:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
static TTIDCSTATUS ConfigIntPolarity(unsigned int uiBusyIntPol,
                                     unsigned int uiBusyIntNum)
{
    unsigned int uiXip;


    uiXip = IRQ_FGET(EXTPOL, XIP); /* get current value of XIP  */


    switch(uiBusyIntNum)           /* use the correct value     */
    {
        case IRQ_EVT_EXTINT4: uiXip = (uiXip & 0x000E)
                                      | uiBusyIntPol;
                              break;
        case IRQ_EVT_EXTINT5: uiXip = (uiXip & 0x000D)
                                      | (uiBusyIntPol << 1);
                              break;
        case IRQ_EVT_EXTINT6: uiXip = (uiXip & 0x000B)
                                      | (uiBusyIntPol << 2);
                              break;
        case IRQ_EVT_EXTINT7: uiXip = (uiXip & 0x0007)
                                      | (uiBusyIntPol << 3);
                              break;
        default:              return TIDC_ERR_BADARGS;
    }


    IRQ_FSET(EXTPOL, XIP, uiXip);  /* and set new value of XIP  */


    return TIDC_NO_ERR;
}




/****************************************************************/
/* InitConvstTimer():                                           */
/**Operation:
 *     - Opens and configures the timer needed for the time base
 *       of the CONVST\ signal.
 *     - Initilizes the timer handle passed into the function.
 *
 * Parameters:
 *      - TIMER_Handle hTimer: Unitialized when the function is
 *        called. Will contain the handle of the opened timer if
 *        the call was successfull.
 *      - unsigned int uiPeriod: Desired value for the timer
 *        period register.
 *      - int iTimerNumber: Number of the timer to be used
 *
 * Return values: Of type TTIDCSTATUS:
 *     - TIDC_NO_ERR: No error occurred
 *     - TIDC_ERR_TIMER: Timer could not be opened
 *
 * Globals modified:
 *      - hConvstTimer in the data converter object
 *
 * Resources used:
 *      - One timer
 */
/****************************************************************/
static TTIDCSTATUS InitConvstTimer(TIMER_Handle *hTimer,
                                   unsigned int uiPeriod,
                                   int iTimerNumber)
{
    /* try to open the timer needed for the CONVST signal       */
    *hTimer = TIMER_open(iTimerNumber, TIMER_OPEN_RESET);


    /* was the open call successfull?                           */
    if (*hTimer == INV)
        return TIDC_ERR_TIMER;


    TIMER_configArgs(*hTimer,
          TIMER_FMK(CTL, INVINP, TIMER_CTL_INVINP_NO)
        | TIMER_FMK(CTL, CLKSRC, TIMER_CTL_CLKSRC_CPUOVR4)
        | TIMER_FMK(CTL, CP, TIMER_CTL_CP_CLOCK)
        | TIMER_FMK(CTL, HLD, TIMER_CTL_HLD_YES)
        | TIMER_FMK(CTL, GO, TIMER_CTL_GO_NO)
        | TIMER_FMK(CTL, PWID, TIMER_CTL_PWID_DEFAULT)
        | TIMER_FMK(CTL, DATOUT, TIMER_CTL_DATOUT_DEFAULT)
        | TIMER_FMK(CTL, INVOUT, TIMER_CTL_INVOUT_NO)
        | TIMER_FMK(CTL, FUNC, TIMER_CTL_FUNC_TOUT),
        uiPeriod,
        0);


    return TIDC_NO_ERR;
}




/****************************************************************/
/* InitEdma():                                                  */
/* Operation:
 *    - Opens the EDMA channel assiciated with the timer in use
 *    - Allocates a parameter table for the EDMA link table and
 *      initializes the associated handle
 *    - Allocates a parameter table for the EDMA stop table and
 *      initializes the associated handle
 *    - Initializes the EDMA parameter table for the stop
 *      transfer to zero.
 *
 * Parameters:
 *     - unsigned int *hEdma: Pointer to the handle of the EDMA
 *       channel for the transfer
 *     - unsigned int *hLink: Pointer to the handle of the
 *       link transfer table
 *     - unsigned int *hStop: Pointer to the handel of the
 *       stop transfer table
 *     - unsigned int uiIntNumber: The interrupt number used
 *       to synchronize the transfer.
 *
 * Return value (of type TTIDCSTATUS):
 *     - TIDC_NO_ERR in case everything was OK
 *     - TIDC_ERR_EDMA if the EDMA channel could not be opened,
 *       or if one of the tables could not be allocated
 *
 * Globals modified: In the data converter object:
 *    - hEdma
 *    - hEdmaLink
 *    - hEdmaStop
 *
 * Resources used:
 *    - One EDMA channel
 *    - Two EDMA parameter RAM tables
 */
/****************************************************************/
static TTIDCSTATUS InitEdma(unsigned int *hEdma,
                    unsigned int *hLink, unsigned int *hStop,
                    unsigned int uiIntNumber)
{
    /* if the channel is not open yet, open it                  */
    if ((*hEdma == EDMA_HINV) || (*hEdma == 0))
    {
        *hEdma = EDMA_open((int)uiIntNumber, EDMA_OPEN_RESET);
        if (*hEdma == EDMA_HINV)
            return TIDC_ERR_EDMA;
    }


    /* get table entries for the link and the stop transfer and */
    /* check if the tables are valid                            */
    *hLink = EDMA_allocTable(-1);
    if (*hLink == EDMA_HINV)
        return TIDC_ERR_EDMA;


    if ((*hStop == 0) || (*hStop == EDMA_HINV))
    {
        *hStop = EDMA_allocTable(-1);
        if (*hStop == EDMA_HINV)
            return TIDC_ERR_EDMA;


        /* the stop transfer table contains only zeros, so it   */
        /* could be initialized now                             */
        EDMA_configArgs(*hStop, 0, 0, 0, 0, 0, 0);
    }


    EDMA_intClear(uiIntNumber);


    return TIDC_NO_ERR;
}




/****************************************************************/
/* InitEmif()                                                   */
/**Operation:
 *     - Sets up the EMIF to the correct timings for the ADS8412
 *
 * Parameters:
 *     - unsigned int *pAddress: Address of the ADS8412
 *
 * Return value: Of type TTIDCSTATUS:
 *     - TIDC_NO_ERR: Everything was OK
 *
 * Globals modified:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
static TTIDCSTATUS InitEmif(volatile unsigned short *pAddress)
{
    volatile unsigned int *pCeCtrl;
    unsigned int uiCeValue;
    unsigned int uiCeSpace;


    uiCeValue = ADS8412_RD_HOLD
                | (ADS8412_MTYPE << 4)
                | (ADS8412_RD_STROBE << 8)
                | (ADS8412_RD_SETUP << 16);


    uiCeSpace = (((unsigned int)pAddress >> 28) & 0x00000007);


    /* det the variable for the CECNTR to the correct value     */
    switch (uiCeSpace)
    {
        case 0: pCeCtrl = (volatile unsigned int *) CECTRL0;
                break;
        case 1: pCeCtrl = (volatile unsigned int *) CECTRL1;
                break;
        case 2: pCeCtrl = (volatile unsigned int *) CECTRL2;
                break;
        case 3: pCeCtrl = (volatile unsigned int *) CECTRL3;
                break;
    }


    *pCeCtrl = (*pCeCtrl & ADS8412_CECTRL_MASK) | uiCeValue;


    return TIDC_NO_ERR;
}




/****************************************************************/
/* SubmitBlock()                                                */
/**Operation: The following operations are performed depending
 *     on of there is already a transfer running or not.
 *     - If this is the first transfer, it initalizes the EDMA
 *       channel registers.
 *     - If this is the second transfer, it initializes the
 *       link table and links the first transfer to the pending
 *       one
 *
 * Parameters:
 *     - EDMA_Handle hSubmit: This is either the handle to the
 *       EDMA channel or the handle to the link table.
 *     - unsigned int uiSrcAddress: Where to read from (ADS8481
 *       address)
 *     - unsigned int uiDstAddress: Address of the buffer to be
 *       filled
 *     - unsigned int uiCount: Number of elements to transfer
 *     - unsigned int uiIntNumber: Number of the interrupt used to
 *       synchronize the transfer (timer interrupt).
 *     - EDMA_Handle hPrevious: Is zero, if this is the first
 *       submitted transfer, contains the pointer to the EDMA
 *       handle, if this is the second submitted buffer.
 *       This parameter will be used for linking the two
 *       transfers together.
 *     - EDMA_Handle hStop: Handle for the stop transfer
 *
 * Return value (of type TTIDCSTATUS):
 *     - TIDC_NO_ERR: No error occurred
 *
 * Globals modified: in DC object:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
static TTIDCSTATUS SubmitBlock(EDMA_Handle hSubmit,
                               unsigned int uiAdsAddress,
                               unsigned int uiBufAddress,
                               unsigned int uiCount,
                               unsigned int uiIntNumber,
                               EDMA_Handle hPrevious,
                               EDMA_Handle hStop)
{
    EDMA_Config cfgEdma;


    /* SRC (channel source address parameter reg) setup         */
    cfgEdma.src = uiAdsAddress;


    /* DST (channel destination addr. parameter reg) setup      */
    cfgEdma.dst = uiBufAddress;


    /* OPT (channel options parameter register) setup           */
    cfgEdma.opt = ADS8412_EDMAOPT_INPUT_VALUE | (uiIntNumber << 16);


    /* CNT (channel transfer count parameter register) setup    */
    cfgEdma.cnt = uiCount;


    /* IDX (channel index parameter register) setup             */
    cfgEdma.idx = 0;


    /* RLD (channel count reload/link address register) setup   */
    cfgEdma.rld = (EDMA_getTableAddress(hStop) & 0x0000FFFFu);


    /* all registers are set-up, configure the DMA channel      */
    EDMA_config(hSubmit, &cfgEdma);


    if (hPrevious != 0)
        EDMA_link(hPrevious, hSubmit);


    return TIDC_NO_ERR;
}

/****************************************************************/
/* END OF t8412_ob.c                                             */
/****************************************************************/
/*TIDC_Wizard Auto Code End}}*/
